// Ejemplo FreeImage 10
// Manipulacin de color
// Abril 2023, Salvador Pozo, Con Clase

#include <iostream>
#include <Freeimage.h>

int main(int argc, char**argv)
{
    FIBITMAP* dib;
    FIBITMAP* dib_rojo;
    FIBITMAP* dib_verde;
	char *lpszPathName;
    FREE_IMAGE_FORMAT fif = FIF_UNKNOWN;

	if(argc < 2) {
        printf("Usar: FreeImage010 <fichero>\n");
        return 0;
	}
	lpszPathName = argv[1];

	fif = FreeImage_GetFileType(lpszPathName, 0);
	if(fif == FIF_UNKNOWN) {
		fif = FreeImage_GetFIFFromFilename(lpszPathName);
	}
	if((fif != FIF_UNKNOWN) && FreeImage_FIFSupportsReading(fif)) {
		dib = FreeImage_Load(fif, lpszPathName, 0);
		std::cout << "Fichero: " << lpszPathName << std::endl;

		if(FreeImage_HasPixels(dib)) {
            dib_rojo = FreeImage_GetChannel(dib, FICC_RED);
            dib_verde = FreeImage_GetChannel(dib, FICC_GREEN);
            FreeImage_SetChannel(dib, dib_rojo, FICC_GREEN);
            FreeImage_SetChannel(dib, dib_verde, FICC_RED);
            FreeImage_Unload(dib_rojo);
            FreeImage_Unload(dib_verde);
            FreeImage_Save(FIF_JPEG, dib, "rojo-verde.jpg", JPEG_DEFAULT);
		}
        FreeImage_Unload(dib);
    }

    return 0;
}
